

/* Basical types */
#ifndef MINREAL
 #define  MINREAL        (-1.7E+300) /*Minimum Real (Float) Number*/
#endif

#ifndef MAXREAL
 #define  MAXREAL        (1.7E+308) /*Maximum Real (Float) Number*/
#endif

#define  CANTOPENFONTFILE   -1
#define  CANTLOADFONTTABLE  -2

#define PRIMITIVEFILEOVERFLOW -1
#define USERPRITIVEFILENOTSPECIFIED -2

#ifndef DOUBLE
 #define DOUBLE double          /* float point type */
#endif

#ifndef _SIZE_T_DEFINED
 typedef unsigned int size_t;
 #define _SIZE_T_DEFINED
#endif

#define BOOLEAN int

#ifndef RW_POINT_DEFINED

typedef struct _rxycoord_record {
                                 DOUBLE x; 
                                 DOUBLE y; 
                                 } _rxycoord; 
typedef _rxycoord RW_POINT;

#define RW_POINT_DEFINED

#endif  /* RW_POINT_DEFINED */


/* these definitions of TRUE and FALSE must NOT be changes
   (This goes too for the HORIZONTAL & VERTICAL */

#define TRUE 1
#define FALSE 0


#define HORIZONTAL 0
#define VERTICAL   1



/*This struct contain information returned by Text() function,      */
/*in order to know the last Device Point generated from text string */
/*and also the last char index sent to ouput device.                */

struct TextOutState{
                    RW_POINT LastPt;
                    int LastChar;            
                    unsigned long LastPrimitiveIndex;
                    
                    };

typedef struct TextOutState TEXTOUPUTSTATE;

/*External variables used up to now by the module outtext.c*/
/*they are defined on text.c module */

typedef struct primitivefile{
            int OpCode;                 /* Id */
            DOUBLE x;                   /* x coord */
            DOUBLE y;                   /* y coord */
            } PrFile;    
typedef struct primitivefile *PRIMITIVEFILE;            


 /*----------  Fonts ----------*/
     /*Font.c file macros */
#define MAXFONT      (129)
#define NOFILE          -1

#ifndef NOMEMORY
 #define NOMEMORY        -2
#endif

#define NOTALLREAD      -3
#define OK               0
#define NOTFOUND        -4
#define MAXFONTSIZE   (512)

               /*Text.c file macros */

#ifndef MAXFILENAME
 #define MAXFILENAME (13)
#endif

#define MAXFONTNAME (13)
#define PFLINETO (1)
#define PFMOVETO (2)

               /*Font.c file variables and structures */
struct _FontTable{
              long OffSet;
              int  Ascii;
              int  Length;
              };


#ifndef MAXBUFFERTOEDIT
 #define MAXBUFFERTOEDIT 21
#endif


               /*Text.c file variables and structures */
struct TextStyle{
        char Name[13];          
        char FontFile[255];
                
        DOUBLE Height;             /* reserved */
        DOUBLE Width;              /* reserved */
        DOUBLE ObliAng;            /* reserved */
                                   /* reserved */
        BOOLEAN BackWard;          /* reserved */
        BOOLEAN UpsideDown;
        BOOLEAN Orient;
        
        };

typedef struct TextStyle TEXTSTYLE;

#ifndef FONT_JUSTIFICATION_DEFINED
enum Just{ ALIGNED, CENTERED, FIT, MIDDLE, RIGHT, DEFAULT/*Left justified */  };
#define LEFT DEFAULT
typedef enum Just FONT_JUSTIFICATION;
#define FONT_JUSTIFICATION_DEFINED
#endif  /*FONT_JUSTIFICATION_DEFINED*/


struct dialogtextstyle {
               struct TextStyle MyTextStyle;
               BOOLEAN   Stylefixed;
               BOOLEAN   Orientation; /* TRUE if Horizontal */
               };         
               
#ifdef __cplusplus
extern "C" {
#endif 

/*Font.c file prototypes  */
int     __cdecl    LoadFont(char * FontFile,char *BufferFonts,size_t FontFileLength, int  *error);
int     __cdecl    GetFontStr(int ,char *, char * );
int     __cdecl    SearchLength(int, unsigned * );
int     __cdecl    GetFileFontsScale(char *);
int     __cdecl    AsciiLength(int);
int     __cdecl    FontFileExists(char * FontFile);
size_t  __cdecl FontFileSize(char * FontFile);
void    __cdecl UserSetPF( PRIMITIVEFILE UserPF, unsigned long UserSizePF );


                  /*Text.c file prototypes  */
int  __cdecl  InitStyle( TEXTSTYLE Style, char *BufferFonts, size_t FontFileLength );
int  __cdecl  PFLineTo(DOUBLE x, DOUBLE y);
int  __cdecl  PFMoveTo(DOUBLE x, DOUBLE y);
void __cdecl  PFLastPos(DOUBLE *x, DOUBLE *y );
void __cdecl  InitPF( void );
TEXTOUPUTSTATE __cdecl Text( const char *Str, FONT_JUSTIFICATION Just, RW_POINT Pt1,  RW_POINT Pt2, DOUBLE Height, DOUBLE AngRot ,char *BufferFonts);
int __cdecl   Char( RW_POINT CurPos, RW_POINT *LastPos, char AscCod, char *BufferFonts);
char * __cdecl FontBufferAddress( void );

                    /*Auxiliary geometry routines */
int    __cdecl   QuadrantPt(RW_POINT p1);  /* V3 */
DOUBLE __cdecl AngTwoPts(RW_POINT Pt1,  RW_POINT Pt2 );
DOUBLE __cdecl DistPts(RW_POINT Pt1, RW_POINT Pt2);

#ifdef __cplusplus
}
#endif 

/*---------------------------------------------------------------*/

                  /*Font Control Codes*/
#define FONTPENDOWN                       1
#define FONTPENUP                         2
#define FONT_DISPLACEMENT_XY              8
#define FONT_MULTIPLE_DISPLACEMENT_XY     9
#define FONT_MULTIPLY_SCALE               4
#define FONT_DIVIDE_SCALE                 3
#define FONT_ONLY_VERTICAL              0xE

/*
#define FONT_PUSH_POS 5
#define FONT_POP_POS 6
*/


       




